<template>
    <div class="container">
        <form>
            <input type="text" name="email" v-model="state.form.email" placeholder="Username">
            <input type="password" name="password" v-model="state.form.password" placeholder="Password">
            <div class="btn-footer-form">
            <button 
                @click.prevent="loginSSO()"
                v-if="!state.loginSuccess['access_token']"
            >
                Login
            </button>
            <div class="logout" v-else>
                <pre>Autenticado em {{state.env.VUE_APP_SSO_URL}} </pre>
                <button @click.prevent="logoutSSO()">Logout</button>
            </div>
            </div>
            <pre>{{state.loginSuccess}}</pre>
        </form>
        <AppUser :aplicacoes="state.loginSuccess.aplicacao" :token="state.loginSuccess.access_token"/>
    </div>
</template>
<script>
import { onMounted, reactive } from 'vue';
import axios from '../services/axios/index'
import localStorage from  '../services/sessao/index'
import AppUser from './AplicacaoUsuario'

const focus = (el) => {
    el.focus()
}

export default {
    directives: {
        focus
    },
    components: {
        AppUser
    },
    setup () {
        const state = reactive({
            env: process.env,
            form: {
                email: '',
                password: ''
            },
            loginSuccess: []
        })

        function loginSSO () {
            axios.postRequest(`${state.env.VUE_APP_SSO_URL}/api/auth/login`, state.form).then(response => {
                state.loginSuccess = response.data.access_token ? response.data: response.data.error
                if (response.status === 200) {
                    localStorage.criarSessao(this.state.loginSuccess)
                }
            })
        }
        function logoutSSO () {
            axios.postRequest(`${state.env.VUE_APP_SSO_URL}/api/auth/logout`, null, {
                headers: {
                    Authorization: `Bearer ${state.loginSuccess.access_token}`
                }
            }).then(response => {
                if (response.status === 200) {
                    state.loginSuccess = []
                    localStorage.removeSessao()
                    return
                }
            })
        }
        onMounted(() => {
            let sessao = localStorage.recuperaSessao()
            if (sessao) {
                state.loginSuccess = sessao
            }
        })

        return {
            state,
            loginSSO,
            logoutSSO,
        }
    }
}
</script>

<style lang='css' scoped>
    @import '../../assets/login/formulario.css';
</style>